%%% -*- TeX-command-extra-options: "-shell-escape" -*-
%%% Local IspellDict: en

% Figure for course on Operating Systems, https://gitlab.com/oer/OS
% Copyright (C) 2018 Jens Lechtenbörger
% License: CC BY-SA 4.0

\documentclass[convert={outext=.png}]{standalone}
% Use sans-serif by default:
\renewcommand{\familydefault}{\sfdefault}

\usepackage{tikz}
\usetikzlibrary{shadows,trees}

\begin{document}
\begin{tikzpicture}[
  grow via three points={one child at (0.8,-0.8) and
  two children at (0.8,-0.8) and (0.8,-1.6)},
  every node/.style={draw,anchor=west,rectangle,rounded corners=4pt},
  meta/.style={thick,fill=blue!20,rounded corners=2pt,drop shadow},
  edge from parent/.style={draw,-latex},
  edge from parent path={(\tikzparentnode.south) |- (\tikzchildnode.west)}]
  \node[meta] {Scheduling Mechanisms}
    child [missing] {}
    child { node[meta] {Fixed priority}
      child { node {FIFO/FCFS}}
      child { node {Round Robin (RR)}}
    }
    child [missing] {}
    child [missing] {}
    child { node[meta] {Dynamic priority}
      child { node {Decay usage}}
      child { node[dashed] {Earliest deadline first}}
    }
    child [missing] {}
    child [missing] {}
    child { node[meta] {Proportional share}
      child { node {Weighted Round Robin (WRR)}}
      child { node {Weighted Fair Queuing (WFQ)}}
      child { node {CFS in Linux}}
    };
\end{tikzpicture}
\end{document}
